//////////////////////////////////////////////////////////////////////////////////////////
//CDLList.h
// ߿ḮƮ Ŭ  κ Դϴ.
//
//
//
//Make day  2000.03.01 by P.S.K
//////////////////////////////////////////////////////////////////////

#ifndef _CDLList_h_
#define _CDLList_h_

#include<windows.h>
#include<stdio.h>
#pragma	pack( push, 1 )
typedef struct _PACKET
{
    char   Data[512]; 
}PACKET;
#pragma pack(pop)
typedef struct _NODE
{
	PACKET  Data;
	_NODE* next;
	_NODE* prev;
}NODE;

template <class T>
class CDLList  
{
private:
	NODE* m_head;
	NODE* m_tail;

public:
	int     m_nIndex;

	CDLList();
	~CDLList();

	void AddHead(T nValue);
	void AddTail(T nValue);

	T TakeHead();
	T TakeTail();

    //void  ShowAll();
    NODE* Search(T nValue);        
	bool  IsEmpty();
    int   GetIndex();
    void  DeleteAll();
    void  Delete(T nValue);

};
// Node.cpp: implementation of the CNode class.
//
//////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

template <class T>
CDLList<T>::CDLList()
{
	m_head=(NODE*)malloc(sizeof(NODE));
	m_tail=(NODE*)malloc(sizeof(NODE));
	
	m_head->next=m_tail;
	m_head->prev=NULL;
	m_tail->next=NULL;
	m_tail->prev=m_head;

	m_nIndex = 0;
}

template <class T>
CDLList<T>::~CDLList()
{
	DeleteAll();
	free(m_head);
	free(m_tail);

	m_head = NULL;
	m_tail = NULL;
}


template <class T>
void CDLList<T>::AddHead(T nValue)
{
    NODE* t = (NODE*)malloc(sizeof(NODE));
	t->Data = nValue;


    t->prev = m_head;
    t->next = m_head->next;
    m_head->next = t;
	m_head->next->prev = t;

    m_nIndex++;

}


template <class T>
void CDLList<T>::AddTail(T nValue)
{
	NODE* t=(NODE*)malloc(sizeof(NODE));
	t->Data = nValue;

	t->next=m_tail;
	t->prev=m_tail->prev;
	
	m_tail->prev->next=t;
	m_tail->prev=t;

	m_nIndex++;
}



template <class T>
T CDLList<T>::TakeHead()
{
	T t_Value;
	if(m_nIndex>0)
	{
		NODE* t = m_head->next;
		t_Value = t->Data  ;
		m_head->next = t->next;
		t->next->prev = m_head;
		
		free(t);
		t = NULL;
		
		m_nIndex--;

		return t_Value;
	}
	else
	{
		memcpy(&t_Value , 0 , sizeof(T) );
		return t_Value;
	}
}





template <class T>
T CDLList<T>::TakeTail()
{	
	T t_Value;
	if(m_nIndex>0)
	{
        NODE* t = m_tail->prev;
        t_Value = t->Data; 

		m_tail->prev = t->prev;
        t->prev->next = m_tail;

        free(t);
		t = NULL;//޸𸮸 Ǯش...NULL ־ش.
    	m_nIndex--;

		return t_Value; 
	}//if
	else
	{
		memcpy(&t_Value , 0 , sizeof(T) );
		return t_Value;
	}
}

/*
template <class T>
void CDLList<T>::ShowAll()
{
	 NODE* t = m_head->next;//  ü Ÿ ...

     while(t->next != NULL)
	 {
		printf("data = %d\n" , t->Data);
		t = t->next;
	 }

}
*/


template <class T>
NODE* CDLList<T>::Search(T nValue)
{
     NODE* t = m_head->next;
	 while(t->next != NULL)
	 {
		if(t->Data == nValue)
		{
			return t;
		}
		t = t->next;
	 }
     return 0;//ã ߴٸ....
}








template <class T>
bool CDLList<T>::IsEmpty()
{
     if(m_nIndex>0)
		 return false;
     else
		 return true;

}



template <class T>
int CDLList<T>::GetIndex()
{
     return  m_nIndex;
}




template <class T>
void CDLList<T>::DeleteAll()
{
	NODE* t = m_head->next;
    NODE* t1;
	while(t->next != NULL)
	{	
		  t1 = t;
	      t = t->next;        
		  free(t1);
		  t1 = NULL;
	
	}
	m_head->next = m_tail;
	m_tail->prev = m_head;

	m_nIndex = 0;
}



template <class T>
void CDLList<T>::Delete(T nValue)
{
      NODE* t = Search(nValue);
      
      if(t->Data == 0)
	  {
           //printf(" á!!!\n");
	  }

	  t->prev->next = t->next;
	  t->next->prev = t->prev;
	  free(t);
      t = NULL;

	  m_nIndex--;
}



#endif//_CDLList_h_