//-----------------------------------------------------
//iocp.cpp
//Using IOCP Server cpp
//
//made in 2001.06.01 by skpark
//-----------------------------------------------------

#include <winsock2.h>
#include <windows.h>
#include <stdio.h>
#include <process.h>
#include "CDLList.h"

#define PORT 10000
#define DATA_BUFSIZE 512
#define MAX_CLIENT    100

typedef struct
{
   OVERLAPPED Overlapped;
   WSABUF     DataBuf;
   DWORD      BytesTrans;
   char       Buffer[DATA_BUFSIZE];   
   int        IOState;
} PER_IO_OPERATION_DATA, *LPPER_IO_OPERATION_DATA;



typedef struct 
{
   SOCKET Socket;
   int client_i;    
   bool Socket_State;
   CDLList<PACKET>     Recv_Q;
   CDLList<PACKET>     Send_Q;
   void Analize(){	   
	   PACKET lPacket = Recv_Q.TakeHead();	   
	   //Need Manipulate Data Routine;
	   Send_Q.AddTail(lPacket);	
   }
   void Send(LPPER_IO_OPERATION_DATA lPerIOData){
	   DWORD SendBytes;
	   ZeroMemory(&(lPerIOData->Overlapped), sizeof(OVERLAPPED));
	   lPerIOData->IOState = 1;//send flag
	   lPerIOData->DataBuf.buf = lPerIOData->Buffer;
	   lPerIOData->DataBuf.len = sizeof(lPerIOData->Buffer);
       if (WSASend(this->Socket , &(lPerIOData->DataBuf), 1, &SendBytes, 0,         
								&(lPerIOData->Overlapped), NULL) == SOCKET_ERROR){
				   if (WSAGetLastError() != ERROR_IO_PENDING){
						printf("WSASend() failed with error %d in ServerWorkerThread\n", WSAGetLastError());
						return ;
				   }
	   }
   }
}PER_HANDLE_DATA, * LPPER_HANDLE_DATA;//port key




PER_HANDLE_DATA                  g_PerHandleData[MAX_CLIENT];
int    c_i = 0;//Total Client Num;
HANDLE g_CompletionPort; 
void IOCPThread(void* temp);
void ServerWorkerThread(void* temp);
void ServerRun();



void main(void)
{
   int i;
   HANDLE ThreadHandle;
   for(i=0;i<MAX_CLIENT;i++)
   {
		g_PerHandleData[i].Socket_State = false;
   }

   if( (ThreadHandle = (HANDLE)_beginthread(IOCPThread , 0, (void*)0 ) )== 0){
         printf("_beginthread() failed with error %d\n", GetLastError());
         return;
	  }  
   CloseHandle(ThreadHandle);
   //Data Analize() & Send()
   ServerRun();
}//void main(void)


void IOCPThread(void *temp)
{
   SOCKADDR_IN InternetAddr;
   SOCKET Listen;
   SOCKET Accept;
   SYSTEM_INFO SystemInfo;

   int i;
   DWORD RecvBytes;
   DWORD Flags;
//   DWORD ThreadID;
   WSADATA wsaData;
   DWORD Ret;

   //initialize WinSock
   if ((Ret = WSAStartup(0x0202, &wsaData)) != 0){
      printf("WSAStartup failed with error %d\n", Ret);
      return;
   }

   //Setup an I/O completion port.   
   if ((g_CompletionPort = CreateIoCompletionPort(INVALID_HANDLE_VALUE, NULL, 0, 0)) == NULL){
      printf( "CreateIoCompletionPort failed with error: %d\n", GetLastError());
      return;
   }
   // Determine how many processors are on the system.
   
   GetSystemInfo(&SystemInfo);

   // Create worker threads based on the number of processors available on the
   // system. Create two worker threads for each processor.   
   for(i = 0; i < (signed)SystemInfo.dwNumberOfProcessors  ; i++)
   {
      HANDLE ThreadHandle;
      // Create a server worker thread and pass the completion port to the thread.
      if( (ThreadHandle = (HANDLE)_beginthread(ServerWorkerThread , 0, (void*)i ) )== 0){
         printf("_beginthread() failed with error %d\n", GetLastError());
         return;
	  }  
	  //CloseHandle(ThreadHandle);
   }

   // Create a listening socket

   if ((Listen = WSASocket(AF_INET, SOCK_STREAM, 0, NULL, 0,
      WSA_FLAG_OVERLAPPED)) == INVALID_SOCKET){
      printf("WSASocket() failed with error %d\n", WSAGetLastError());
      return;
   } 

   InternetAddr.sin_family = AF_INET;
   InternetAddr.sin_addr.s_addr = htonl(INADDR_ANY);
   InternetAddr.sin_port = htons(PORT);

   if (bind(Listen, (PSOCKADDR) &InternetAddr, sizeof(InternetAddr)) == SOCKET_ERROR){
      printf("bind() failed with error %d\n", WSAGetLastError());
      return;
   }

   // Prepare socket for listening
   if (listen(Listen, 5) == SOCKET_ERROR){
      printf("listen() failed with error %d\n", WSAGetLastError());
      return;
   }

   // Accept connections and assign to the completion port.

   while(TRUE)
   {      
	  //blocking function 
      if ((Accept = WSAAccept(Listen, NULL, NULL, NULL, 0)) == SOCKET_ERROR){
         printf("WSAAccept() failed with error %d\n", WSAGetLastError());
         return;
      }
	  // Associate the accepted socket with the original completion port.      
      printf("Socket number %d connected\n"  , Accept);
      g_PerHandleData[c_i].Socket = Accept;
	  g_PerHandleData[c_i].Socket_State = true;
      g_PerHandleData[c_i].client_i = c_i;  
      if (CreateIoCompletionPort((HANDLE) Accept , g_CompletionPort, (DWORD) &g_PerHandleData[c_i] , 0) == NULL){
         printf("CreateIoCompletionPort failed with error %d\n", GetLastError());
         return;
      } 
      // Create per I/O socket information structure to associate with the 
      // WSARecv call below.
	  LPPER_IO_OPERATION_DATA lPerIOData;
      lPerIOData = (LPPER_IO_OPERATION_DATA)malloc(sizeof(PER_IO_OPERATION_DATA));
      lPerIOData->IOState = 0; //recv
	  ZeroMemory( &(lPerIOData->Overlapped), sizeof(OVERLAPPED)  );   
      lPerIOData->BytesTrans = 0;
      lPerIOData->DataBuf.len = DATA_BUFSIZE;
      lPerIOData->DataBuf.buf = lPerIOData->Buffer;
      Flags = 0;      
      if (WSARecv( g_PerHandleData[c_i].Socket , &(lPerIOData->DataBuf), 1, &RecvBytes, &Flags,//Flags = 0
                                                     &(lPerIOData->Overlapped), NULL) == SOCKET_ERROR){
         if (WSAGetLastError() != ERROR_IO_PENDING){
            printf("WSARecv() failed with error %d\n", WSAGetLastError());
           return;
         }
      }//if (WSARecv(A     
      c_i++;
   }//while(TRUE)
}//void IOCPThread(void *temp)





void ServerWorkerThread(void* temp)
{
   int ThreadID;
   HANDLE CompletionPort = g_CompletionPort;
   DWORD lBytesTransferred;
   LPPER_IO_OPERATION_DATA lPerIOData;
   LPPER_HANDLE_DATA lPerHandleData;
   DWORD RecvBytes;   
   ThreadID = (int)temp;
   while(1)
   {	   
   	   if (GetQueuedCompletionStatus(CompletionPort, &lBytesTransferred,
                                             (LPDWORD)&lPerHandleData, (LPOVERLAPPED *) &lPerIOData, INFINITE) == 0)
       {//Ŭ̾Ʈ ϶ 64..
		    if(GetLastError() == 64){;}
            else
			{
				printf("GetQueuedCompletionStatus failed with error %d\n", GetLastError());
				return ;
			}
       }
	   //closesocket() ó
       if(lBytesTransferred == 0)
       {
           printf("Closing socket %d\n", lPerHandleData->Socket);

           if (closesocket(lPerHandleData->Socket) == SOCKET_ERROR)
		   {
              if(GetLastError() == 10038)
			  {
				  continue;
			  }
			  else
			  {
				printf("closesocket() failed with error %d\n", WSAGetLastError());
                return ;
			  }
		   }
		   c_i--;
		   lPerHandleData->Socket_State = false;
           GlobalFree(lPerHandleData);
           GlobalFree(lPerIOData);
           continue;
      }//if(lBytesTransferred == 0)

	  //recv	
      if(lPerIOData->IOState == 0 ){
		   PACKET lPacket;
		   memcpy(lPerIOData->Buffer , lPerIOData->DataBuf.buf , sizeof(lPerIOData->Buffer)); 		   
		   printf("Ÿ  %s\n" , lPerIOData->DataBuf.buf);
		   memcpy(lPacket.Data , lPerIOData->Buffer , sizeof(lPacket.Data));
		   lPerHandleData->Recv_Q.AddTail(lPacket);
	       ZeroMemory(&(lPerIOData->Overlapped), sizeof(OVERLAPPED));   
		   lPerIOData->BytesTrans = 0;
		   lPerIOData->DataBuf.len = DATA_BUFSIZE;	  
		   lPerIOData->DataBuf.buf = lPerIOData->Buffer;
		   DWORD Flags = 0;		   
		   if (WSARecv( lPerHandleData->Socket , &(lPerIOData->DataBuf), 1, &RecvBytes, &Flags,//Flags = 0
														 &(lPerIOData->Overlapped), NULL) == SOCKET_ERROR){
		    	 if (WSAGetLastError() != ERROR_IO_PENDING){
				     printf("WSARecv() failed with error %d ServerWorkerThread \n", WSAGetLastError());
				     return;
				 }
		   }//if (WSARecv(A		 	
		   continue;		   
      }//if(lPerHandleData->bRecv == true )
   
	  //send
	  if(lPerIOData->IOState == 1){
           printf(" %dϿ %d Ʈ  \n" , lPerHandleData->client_i , lBytesTransferred);			  
		   if(!lPerHandleData->Send_Q.IsEmpty()){
			    DWORD SendBytes;
				ZeroMemory(&(lPerIOData->Overlapped), sizeof(OVERLAPPED));
				lPerIOData->IOState = 1;//send flag
				memcpy(lPerIOData->Buffer , (const void *)&(lPerHandleData->Send_Q.TakeHead()), sizeof(DATA_BUFSIZE));
				lPerIOData->DataBuf.buf = lPerIOData->Buffer;
				lPerIOData->DataBuf.len = sizeof(lPerIOData->Buffer);
				if (WSASend(lPerHandleData->Socket , &(lPerIOData->DataBuf), 1, &SendBytes, 0,         
										&(lPerIOData->Overlapped), NULL) == SOCKET_ERROR){
						if (WSAGetLastError() != ERROR_IO_PENDING){
							printf("WSASend() failed with error %d in ServerWorkerThread\n", WSAGetLastError());
							return ;
						}
				}//wsasend
		   }//IsEmpty()
	  }//	
   }//while(1)
   
}//void RecvWorkerThread




void ServerRun()
{
	LPPER_IO_OPERATION_DATA lPerIOData;
    lPerIOData = (LPPER_IO_OPERATION_DATA)malloc(sizeof(PER_IO_OPERATION_DATA));
	while(1){
		for(int i=0;i<c_i;i++)
		{
			if(!g_PerHandleData[i].Recv_Q.IsEmpty()){
				g_PerHandleData[i].Analize();
				memcpy(lPerIOData->Buffer , (const void *)&(g_PerHandleData[i].Send_Q.TakeHead()), sizeof(DATA_BUFSIZE));
				for(int j=0;j<c_i;j++)
				{
					g_PerHandleData[j].Send(lPerIOData);
					Sleep(1);
				}				
			}
			Sleep(1);
		}
		Sleep(1);
	}//while(1)
}//void DataAnalysis()